# 扩展欧几里得
gcd(a,b)
    return b==0?a
我们观察到：欧几里德算法停止的状态是： a'= gcd ， b' = 0 ，(a',b'是递归最后一层时参数的值)那么，这是否能给我们求解 x y 提供一种思路呢？
a'x + b'y = gcd  此时x=1,y为任意数
因为，这时候，只要 a = gcd 的系数是 1 ，那么只要 b 的系数是 0 或者其他值
（无所谓是多少，反正任何数乘以 0 都等于 0 但是a 的系数一定要是 1），这时，我们就会有： a'*1 + b'*0 = gcd

    当然这是最终状态，但是我们是否可以从最终状态反推到最初的状态呢？

    假设当前我们要处理的是求出 a 和 b的最大公约数，并求出 x 和 y 使得 a*x + b*y= gcd    ……(1)，--->要求的
    而我们已经求出了下一个状态：b 和 a%b 的最大公约数，并且求出了一组x1 和y1 使得： b*x1 + (a%b)*y1 = gcd (2) ，-->下一个状态
    那么这两个相邻的状态之间是否存在一种关系呢？

    a%b = k  ==>  a = b*(a/b) +k  "/"舍掉余数的除法 ==> k=a-(a/b)*b
    我们知道： a%b = a - (a/b)*b（这里的 “/” 指的是整除，例如 5/2=2 , 1/3=0），那么，我们可以进一步得到：

        gcd = b*x1 + (a-(a/b)*b)*y1

            = b*x1 + a*y1 – (a/b)*b*y1

            = a*y1 + b*(x1 – a/b*y1)        ……(3)

    对比之前我们的状态,式(3)和式(1)：求一组 x 和 y 使得：a*x + b*y = gcd ，是否发现了什么？

    这里：

        x = y1

        y = x1 – a/b*y1

    这就是递推式,注意x,y是递归过程中的上一层,x1,y1是下一层(下一个状态)得到的值



# 乘法逆元

1.乘法逆元（在维基百科中也叫倒数，当然是 mod p后的,其实就是倒数不是吗？）:

如果ax≡1 (mod p),且gcd(a,p)=1（a与p互质），则称a关于模p的乘法逆元为x。

为什么可以用扩展欧几里得求得逆元？

我们都知道模就是余数，比如12%5=12-5*2=2，18%4=18-4*4=2。（/是程序运算中的除）

那么ax≡1 (mod p)即ax-yp=1.把y写成+的形式就是ax+py=1，为方便理解下面我们把p写成b就是ax+by=1。
就表示x是a的模b乘法逆元，y是b的模a乘法逆元。然后就可以用扩展欧几里得求了。

知道逆元怎么算之后，那么乘法逆元有什么用呢？

做题时如果结果过大一般都会让你模一个数，确保结果不是很大，而这个数一般是1e9+7，而且这个数又是个素数，
加减乘与模运算的顺序交换不会影响结果，但是除法不行。有的题目要求结果mod一个大质数，如果原本的结果中有除法，比如除以a,那就可以乘以a的逆元替代。
（除一个数等于乘它的倒数，虽然这里的逆元不完全是倒数，但可以这么理解，毕竟乘法逆元就是倒数的扩展）。

